//
//   @file    fploughshare.cxx         
//   
//
//   @author M Sutton
//
//   $Id: fploughshare.cxx, v0.0   Thu 19 Jul 2018 20:11:36 CEST sutt $
//
//   Copyright (C) 2018 M Sutton (sutt@cern.ch)    


#include <string>

#include "ploughshare.h"



/// copy string to a fortran string
 
void ctofstring( const std::string& s, char* fs, int flen ) {
  int i=0;
  if ( s.size()>flen ) throw ploughshare::exception( "string length (" + std::to_string(flen)+") not long enough to store "+s );
  while ( i<s.size() ) { fs[i] = s[i]; i++; } 
  while ( i<flen ) fs[i++] = 0;
}



/// this is the central data base
/// it is static so noone else can 
/// mess with it

static ploughshare p;


extern "C" int fetch_( char* s, int _len ) { 
  //  std::string dataset(s, 0, _len );
  return p.fetch( std::string( s, 0, _len ) );
}


extern "C" int datsetsize_( char* s, int _len ) { 
  //  std::string dataset(s, 0, _len );
  return p.size( std::string( s, 0, _len ) );
}


extern "C"  void getdatasetpath_( const char* datasetin, char* gridpath, int _dlen, int _glen) {
  //  std::string dataset(datasetin,0,_dlen);
  //  std::string gpath = p.path(dataset);
  //  if ( gpath.size() > _glen ) {
  //        std::cerr << "getgridpath():passed in string not long enough " << _glen << " < " << gpath.size() << " for path " << gpath << std::endl;
  //        throw std::exception();
  //  }
  //  ctofstring( gpath, gridpath, _glen ); 
  ctofstring( p.path( std::string( datasetin, 0, _dlen ) ), gridpath, _glen ); 
}


extern "C"  void getgridpath_( const char* datasetin, const int& igrid,  char* gridpath, int _dlen, int _glen) {
  //  std::string dataset(datasetin,0,_dlen);
  //  std::string gpath = p.grids(dataset).at(igrid);
  //  if ( gpath.size() > _glen ) {
  //        std::cerr << "getgrid():passed in string not long enough " << _glen << " < " << gpath.size() << " for path " << gpath << std::endl;
  //        throw std::exception();
  //  }
  //  ctofstring( gpath, gridpath, _glen ); 
  ctofstring( p.grids( std::string( datasetin, 0, _dlen ) ).at(igrid), gridpath, _glen ); 
}





